diff --git a/src/modules/rlm_rest/rest.c b/src/modules/rlm_rest/rest.c
index d0fa9758006d..77171ae8d656 100644
--- a/src/modules/rlm_rest/rest.c
+++ b/src/modules/rlm_rest/rest.c
@@ -1513,14 +1513,14 @@ static size_t rest_response_body(void *ptr, size_t size, size_t nmemb, void *use
 		return t;
 
 	default:
-		if ((t + 1) > (ctx->alloc - ctx->used) {
+		if ((t + 1) > (ctx->alloc - ctx->used)) {
 			ctx->alloc += ((t + 1) > REST_BODY_INIT) ? t + 1 : REST_BODY_INIT;
 
 			tmp = ctx->buffer;
 			ctx->buffer = talloc_array(NULL, char, ctx->alloc);
 			/* If data has been written previously */
 			if (tmp) {
-				strlcpy(ctx->buffer, tmp, (ctx->used + 1));
+				memcpy(ctx->buffer, tmp, ctx->used);
 				talloc_free(tmp);
 			}
 		}
